/* learnit.c */
/* Perceptron Learning Program */

#include <stdio.h>
#include <stdlib.h>

int x[4][3]={{1,0,0},
	     {1,1,0},
	     {1,0,1},
	     {1,1,1}};

float w[3],corr;

int r[4],resp,diff,i,wrongresp=1,c;
char (choice);

main() {
    clrscr();
    for (i=0;i<4;i++)
    { printf(
     "Type in the correct response for these inputs %d %d:",
     x[i][1],x[i][2]);
     scanf("%d",&r[i]);
    }

puts("Type 1 to assign your own weights or 2 to have the weights");
puts("assigned randomly.");

if (choice=getch()=='1') {

    printf("first weight\n");
    scanf("%f",&w[1]);
    printf("second weight\n");
    scanf("%f",&w[2]);
    printf("zeroth weight (-1 times the threshold)\n");
    scanf("%f",&w[0]); }

else {

     randomize();
     w[0]=random(1000)/1000.0;
     w[1]=random(1000)/1000.0;
     w[2]=random(1000)/1000.0;}

 printf("\nThe initial weights are %f %f %f\n",w[1],w[2],w[0]);

 printf("\nWhat is the value of your correction factor? ");
 scanf("%f",&corr);
 printf("\n");

 while (wrongresp){
    wrongresp=0;
    for (i=0;i<4;i++){
	resp=((w[0]*x[i][0]+w[1]*x[i][1]+w[2]*x[i][2])>=0);
        diff=r[i]-resp;
	printf(
	"test inputs %d %d, response %d, correct response  %d.\n",
	x[i][1],x[i][2],resp,r[i]);
        if (diff!=0) {
            wrongresp=1;
            w[0]=w[0]+diff*corr*x[i][0];
	    w[1]=w[1]+diff*corr*x[i][1];
	    w[2]=w[2]+diff*corr*x[i][2];
	    printf("New weights %f %f %f \n\n",w[1],w[2],w[0]);
            }
        else
	    printf("No adjustment necessary\n\n");     /* end if */
	    puts("Press ESC to end, any other key to continue\n");
	    c=getch();
	    if(c==27) return(0);

	}  /* end for */

} /* end while */

 printf("The final weights are w1=%f w2=%f w0=%f \n\n"
 ,w[1],w[2],w[0]);

}    /* end main */
